﻿Type=Service
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: false
	#ExcludeFromLibrary: True
#End Region

#Region --- Service parts ---
Sub Process_Globals
	
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 
	' Get these values from your Firebase console:
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 
	
	' .... change this to your own ID and DBSECRET	....
	
	Dim strFirebaseProjectId As String = "project-11111111111   your project id  1111111"  
	Dim strFirebaseDbSecret As String  = "111111111    your database secret      1111111" ' #wtd Save encryptet in KVS later!!! 
	
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 
	
	
	Dim strFirebaseProjectRefUrl As String = $"https://${strFirebaseProjectId}.firebaseio.com/"$

	Dim auth As FirebaseAuth			
	
	Dim FiBaRtDb As FirebaseDatabase 	

	'Public storage As FilrebaseStorage
	Public bucket As String = $"gs://${strFirebaseProjectId}.appspot.com"$ ' from Firebase console ("Storage")
		
	Dim tmrFiBaAuthTokenRefresh As Timer
	Dim strFirebaseSignedInUserToken As String = ""
	Dim strFirebaseSignedInUser As String = ""
	Dim strFirebaseSignedInUserID As String = ""
	Dim strFirebaseSignedInUserEMail As String = ""
	Dim strFirebaseSignedInUserPictureUrl As String= ""

	Dim fbdb As fibadbhelp

'	Public kvs As KeyValueStore	

End Sub

Sub Service_Create
	' -- -- -- -- -- -- -- -- -- -- -- -- -- 
	' Firebase 
	' -- -- -- -- -- -- -- -- -- -- -- -- -- 
	auth.Initialize("auth")
	tmrFiBaAuthTokenRefresh.Initialize("tmrFiBaAuthTokenRefresh", 58 *DateTime.TicksPerMinute)  ' Avoid unvalid tokens
	tmrFiBaAuthTokenRefresh.Enabled = True

	'storage.Initialize("storage", bucket) ' we use this later to handle pictures or other files 
	FiBaRtDb.Initialize("FiBaRtDb")
	FiBaRtDb.PersistenceEnabled = True  ' https://firebase.google.com/docs/reference/android/com/google/firebase/database/FirebaseDatabase.html#setPersistenceEnabled(boolean)
	FiBaRtDb.goOnline
		
	' ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 
	' Does anyone know how to set the debug level?
		''FiBaRtDb.LogLevel = ???? '"DEBUG" ' "INFO", "NONE" 
	' ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 		
		
End Sub

Sub Service_Start (StartingIntent As Intent)
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	tmrFiBaAuthTokenRefresh.Enabled = False
End Sub

#End Region

#Region --- Firebase Auth Tokens ---
Sub tmrFiBaAuthTokenRefresh_Tick
	Log("#-tmrFiBaAuthTokenRefresh_Tick")
	If strFirebaseSignedInUserToken.Length > 0 Then 
		CallSubDelayed(Me, "authTokenRefresh")
	End If
End Sub
Sub authTokenRefresh
	Log("#-starter.authTokenRefresh")	
	auth.GetUserTokenId(auth.CurrentUser, True)	
End Sub

Sub auth_TokenAvailable (User As FirebaseUser, Success As Boolean, TokenId As String)
	Log("#-starter.auth_TokenAvailable, Success=" & Success ) '& ", TokenId=" & TokenId)
	If Success Then 
		strFirebaseSignedInUserToken = TokenId
	Else
		strFirebaseSignedInUserToken = ""
	End If
End Sub
#End Region